import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
public class MovingText extends JLabel implements ActionListener {
    private javax.swing.Timer t = new javax.swing.Timer(50, this);
    private String str;
    private int xPos = 0;
    public MovingText(String str) {
        this.str = str;
        setBackground(Color.YELLOW);
        setForeground(Color.BLUE);
        setOpaque(true);
        t.restart();
    }//konstruktor

    public void paintComponent(Graphics pen) {
        super.paintComponent(pen);
        FontMetrics fm = pen.getFontMetrics();
        int s = fm.stringWidth(str);
        if (xPos < getWidth() + s)
            xPos = xPos + 1;
        else 
            xPos = 0;
        int yPos = getHeight()/2 + fm.getHeight()/2;
        pen.drawString(str, getWidth()-xPos, yPos);
    }//paintComponent

    public void actionPerformed(ActionEvent e) {
        repaint();
    }//actionPerformed

    public void changeText(String str) {
        this.str = str;
    }//changeText
}//MovingText 
